package com.alterdekim.flash.decompiler;

import com.alterdekim.flash.decompiler.compiler.FlashCompiler;
import com.alterdekim.flash.decompiler.tag.DoAction;
import com.alterdekim.flash.decompiler.tag.TagType;
import com.alterdekim.flash.decompiler.translator.Flash2Java;
import com.alterdekim.flash.decompiler.translator.Java2Flash;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardOpenOption;

@Slf4j
public class Main {
    public static void main(String[] args) throws Exception {
        FlashDecompiler decompiler = new FlashDecompiler();
        ShockwaveFile file = decompiler.loadFromFile(new File("D:\\Documents\\FlashProjects\\Untitled-2.swf")); //

        DoAction da = (DoAction) file.getTags()
                .stream()
                .filter(p -> p.getType() == TagType.DoAction)
                .findFirst()
                .get();

        ObjectMapper objectMapper = new ObjectMapper();
        File out = new File("dec.json");
        if( out.exists() ) out.delete();
        //objectMapper.writeValue(out, new Flash2Java(da).convert());
        var j2f = new Java2Flash().convert(new Flash2Java(da).convert());
        Files.write(Path.of("export1.swf"), new FlashCompiler(j2f).compile(), StandardOpenOption.CREATE);
    }
}